; ///////////////////////////////////////////////////////////////////////////
; 
;                           PureLZMA Packer DLL INCLUDE
;
; ///////////////////////////////////////////////////////////////////////////
;
; Same PureLZMA_* functions as the eponymous userlibrary (use it's help file),
; but named PureLZMA_DLL_*
;
#UseStatic = #True
;
CompilerIf Defined(LZMA_ArchiveInfo, #PB_Structure) = #False
Structure LZMA_ArchiveInfo
  CRCUnpacked.l
  CRCPacked.l
  LengthUnpacked.l
  LengthPacked.l
  LZMAFlags.l
  FileAttributes.l
  FileName.s
EndStructure
CompilerEndIf
;
; LZMA Flags :
#LZMA_Flag_Stored = 0
#LZMA_Flag_Compressed = 1
#LZMA_Flag_Crypted = 2
#LZMA_Flag_Deleted = 4
;
#PureLZMA_DontStorePath = 0
#PureLZMA_StorePathAbsolute = 1 ; store path
#PureLZMA_StorePathRelative = 2 ; store path relative to base directory
;
CompilerIf #UseStatic
  ;
  ; THE STATIC WAY
  ;
  ; Import Functions from library
  ;
  Import "PureLZMA_Packer.lib"
    PureLZMA_DLL_SetOptions(Opt_Level, DictSize, lc, lp, pb, fb, NumThreads) As "_PureLZMA_DLL_SetOptions@28" ; Set LZMA compression options
    PureLZMA_DLL_Compress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") As "_PureLZMA_DLL_Compress@12" ; Compress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
    PureLZMA_DLL_UnCompress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") As "_PureLZMA_DLL_UnCompress@12" ; Uncompress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
    PureLZMA_DLL_FreeBuffer(*Buffer) As "_PureLZMA_DLL_FreeBuffer@4" ; Free LZMA output buffer
    ;
    PureLZMA_DLL_Archive_AddFiles(FileMask.s, Recursive.l, StorePath.l, EncryptionKey.s = "", *ProgressionCallback = #Null) As "_PureLZMA_DLL_Archive_AddFiles@20" ; Add files to current archive [return number of compressed files]
    PureLZMA_DLL_Archive_Close() As "_PureLZMA_DLL_Archive_Close@0" ; Close current archive
    PureLZMA_DLL_Archive_Compress(FileName.s, KeepPath.l, EncryptionKey.s = "") As "_PureLZMA_DLL_Archive_Compress@12" ; Add a file to the current archive [return value is < 0 if error]
    PureLZMA_DLL_Archive_CompressMem(*MemoryBuffer, MemoryBufferLen.l, FileName.s, EncryptionKey.s = "") As "_PureLZMA_DLL_Archive_CompressMem@16" ; Add a memory buffer to the current archive [return value is < 0 if error]
    PureLZMA_DLL_Archive_Create(Archive.s) As "_PureLZMA_DLL_Archive_Create@4" ; Create a new archive [returns #Null if failed]
    PureLZMA_DLL_Archive_CreateSFX(SFXStub.s)  As"_PureLZMA_DLL_Archive_CreateSFX@4" ; Create a new SFX archive [returns #Null if failed]
    PureLZMA_DLL_Archive_DeleteRecord() As "_PureLZMA_DLL_Archive_DeleteRecord@0" ; Delete current archived record [delayed until archive is closed ; SFX is not supported]
    PureLZMA_DLL_Archive_Extract(FileName.s, EncryptionKey.s = "") As "_PureLZMA_DLL_Archive_Extract@8" ; Extract current record from archive [returns #True if success]
    PureLZMA_DLL_Archive_ExtractMem(*MemoryBuffer, MemoryBufferLen.l, EncryptionKey.s = "") As "_PureLZMA_DLL_Archive_ExtractMem@12" ; Extract current record from archive to memory buffer [returns #True if success]
    PureLZMA_DLL_Archive_FindFirst() As "_PureLZMA_DLL_Archive_FindFirst@0" ; Find first record in archive [returns #True if success]
    PureLZMA_DLL_Archive_FindNext() As "_PureLZMA_DLL_Archive_FindNext@0" ; Find next record in archive [returns #True if success]
    PureLZMA_DLL_Archive_GetArchiveInfo(*ArchiveInfo.LZMA_ArchiveInfo) As "_PureLZMA_DLL_Archive_GetArchiveInfo@4" ; Get archived record information [returns #True if success]
    PureLZMA_DLL_Archive_GetCRC() As "_PureLZMA_DLL_Archive_GetCRC@0" ; Calculate CRC32 for current archived record
    PureLZMA_DLL_Archive_Read(Archive.s) As "_PureLZMA_DLL_Archive_Read@4" ; Read an existing archive [returns #Null if failed]
    PureLZMA_DLL_Archive_ReadSFX(Archive.s) As "_PureLZMA_DLL_Archive_ReadSFX@4" ; Read an existing SFX archive [returns #Null if failed]
    PureLZMA_DLL_Archive_Update(Archive.s) As "_PureLZMA_DLL_Archive_Update@4" ; Opens an existing archive for update [returns #Null if failed]
    PureLZMA_DLL_Archive_UpdateSFX(Archive.s) As "_PureLZMA_DLL_Archive_UpdateSFX@4" ; Opens an existing SFX archive for update [returns #Null if failed]
    ;
    PureLZMA_DLL_MemArchive_Close() As "_PureLZMA_DLL_MemArchive_Close@0" ; Close current archive
    PureLZMA_DLL_MemArchive_Extract(FileName.s, EncryptionKey.s = "") As "_PureLZMA_DLL_MemArchive_Extract@8" ; Extract current record from memory archive [returns #True if success]
    PureLZMA_DLL_MemArchive_ExtractMem(*MemoryBuffer, MemoryBufferLen.l, EncryptionKey.s = "") As "_PureLZMA_DLL_MemArchive_ExtractMem@12" ; Extract current record from memory archive to memory buffer [returns #True if success]
    PureLZMA_DLL_MemArchive_FindFirst() As "_PureLZMA_DLL_MemArchive_FindFirst@0" ; Find first record in memory archive [returns #True if success]
    PureLZMA_DLL_MemArchive_FindNext() As "_PureLZMA_DLL_MemArchive_FindNext@0" ; Find next record in memory archive [returns #True if success]
    PureLZMA_DLL_MemArchive_GetArchiveInfo(*ArchiveInfo.LZMA_ArchiveInfo) As "_PureLZMA_DLL_MemArchive_GetArchiveInfo@4" ; Get archived record information [returns #True if success]
    PureLZMA_DLL_MemArchive_GetCRC() As "_PureLZMA_DLL_MemArchive_GetCRC@0" ; Calculate CRC32 for current archived record
    PureLZMA_DLL_MemArchive_Read(*ArchiveBuffer, ArchiveBufferLen.l) As "_PureLZMA_DLL_MemArchive_Read@8" ; Read a memory archive [returns #Null if failed]
  EndImport
  ;
  ; or
  ;
CompilerElse
  ;
  ; THE DYNAMIC WAY
  ;
  ; Define prototypes
  ;
  Prototype.l Proto_PureLZMA_DLL_SetOptions(Opt_Level, DictSize, lc, lp, pb, fb, NumThreads) ; Set LZMA compression options
  Prototype.l Proto_PureLZMA_DLL_Compress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") ; Compress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
  Prototype.l Proto_PureLZMA_DLL_UnCompress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") ; Uncompress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
  Prototype.l Proto_PureLZMA_DLL_FreeBuffer(*Buffer) ; Free LZMA output buffer
  ;
  Prototype.l Proto_PureLZMA_DLL_Archive_AddFiles(FileMask.s, Recursive.l, StorePath.l, EncryptionKey.s = "", *ProgressionCallback = #Null) ; Add files to current archive [return number of compressed files]
  Prototype.l Proto_PureLZMA_DLL_Archive_Close() ; Close current archive
  Prototype.l Proto_PureLZMA_DLL_Archive_Compress(FileName.s, KeepPath.l, EncryptionKey.s = "") ; Add a file to the current archive [return value is < 0 if error]
  Prototype.l Proto_PureLZMA_DLL_Archive_CompressMem(*MemoryBuffer, MemoryBufferLen.l, FileName.s, EncryptionKey.s = "") ; Add a memory buffer to the current archive [return value is < 0 if error]
  Prototype.l Proto_PureLZMA_DLL_Archive_Create(Archive.s) ; Create a new archive [returns #Null if failed]
  Prototype.l Proto_PureLZMA_DLL_Archive_CreateSFX(SFXStub.s) ; Create a new SFX archive [returns #Null if failed]
  Prototype.l Proto_PureLZMA_DLL_Archive_DeleteRecord() ; Delete current archived record [delayed until archive is closed ; SFX is not supported]
  Prototype.l Proto_PureLZMA_DLL_Archive_Extract(FileName.s, EncryptionKey.s = "") ; Extract current record from archive [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_Archive_ExtractMem(*MemoryBuffer, MemoryBufferLen.l, EncryptionKey.s = "") ; Extract current record from archive to memory buffer [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_Archive_FindFirst() ; Find first record in archive [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_Archive_FindNext() ; Find next record in archive [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_Archive_GetArchiveInfo(*ArchiveInfo.LZMA_ArchiveInfo) ; Get archived record information [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_Archive_GetCRC() ; Calculate CRC32 for current archived record
  Prototype.l Proto_PureLZMA_DLL_Archive_Read(Archive.s) ; Read an existing archive [returns #Null if failed]
  Prototype.l Proto_PureLZMA_DLL_Archive_ReadSFX(Archive.s) ; Read an existing SFX archive [returns #Null if failed]
  Prototype.l Proto_PureLZMA_DLL_Archive_Update(Archive.s)  ; Opens an existing archive for update [returns #Null if failed]
  Prototype.l Proto_PureLZMA_DLL_Archive_UpdateSFX(Archive.s) ; Opens an existing SFX archive for update [returns #Null if failed]
  ;
  Prototype.l Proto_PureLZMA_DLL_MemArchive_Close() ; Close current archive
  Prototype.l Proto_PureLZMA_DLL_MemArchive_Extract(FileName.s, EncryptionKey.s = "") ; Extract current record from memory archive [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_MemArchive_ExtractMem(*MemoryBuffer, MemoryBufferLen.l, EncryptionKey.s = "") ; Extract current record from memory archive to memory buffer [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_MemArchive_FindFirst() ; Find first record in memory archive [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_MemArchive_FindNext() ; Find next record in memory archive [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_MemArchive_GetArchiveInfo(*ArchiveInfo.LZMA_ArchiveInfo) ; Get archived record information [returns #True if success]
  Prototype.l Proto_PureLZMA_DLL_MemArchive_GetCRC() ; Calculate CRC32 for current archived record
  Prototype.l Proto_PureLZMA_DLL_MemArchive_Read(*ArchiveBuffer, ArchiveBufferLen.l) ; Read a memory archive [returns #Null if failed]
  ;
  ; Get functions
  ;
  PureLZMA = OpenLibrary(#PB_Any, "PureLZMA_Packer.DLL")
  If PureLZMA
    PureLZMA_DLL_SetOptions.Proto_PureLZMA_DLL_SetOptions = GetFunction(PureLZMA, "PureLZMA_DLL_SetOptions")
    PureLZMA_DLL_Compress.Proto_PureLZMA_DLL_Compress = GetFunction(PureLZMA, "PureLZMA_DLL_Compress")
    PureLZMA_DLL_UnCompress.Proto_PureLZMA_DLL_UnCompress = GetFunction(PureLZMA, "PureLZMA_DLL_UnCompress")
    PureLZMA_DLL_FreeBuffer.Proto_PureLZMA_DLL_FreeBuffer = GetFunction(PureLZMA, "PureLZMA_DLL_FreeBuffer")
    ;
    PureLZMA_DLL_Archive_AddFiles.Proto_PureLZMA_DLL_Archive_AddFiles = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_AddFiles")
    PureLZMA_DLL_Archive_Close.Proto_PureLZMA_DLL_Archive_Close = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_Close")
    PureLZMA_DLL_Archive_Compress.Proto_PureLZMA_DLL_Archive_Compress = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_Compress")
    PureLZMA_DLL_Archive_CompressMem.Proto_PureLZMA_DLL_Archive_CompressMem = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_CompressMem")
    PureLZMA_DLL_Archive_Create.Proto_PureLZMA_DLL_Archive_Create = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_Create")
    PureLZMA_DLL_Archive_CreateSFX.Proto_PureLZMA_DLL_Archive_CreateSFX = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_CreateSFX")
    PureLZMA_DLL_Archive_DeleteRecord.Proto_PureLZMA_DLL_Archive_DeleteRecord = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_DeleteRecord")
    PureLZMA_DLL_Archive_Extract.Proto_PureLZMA_DLL_Archive_Extract = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_Extract")
    PureLZMA_DLL_Archive_ExtractMem.Proto_PureLZMA_DLL_Archive_ExtractMem = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_ExtractMem")
    PureLZMA_DLL_Archive_FindFirst.Proto_PureLZMA_DLL_Archive_FindFirst = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_FindFirst")
    PureLZMA_DLL_Archive_FindNext.Proto_PureLZMA_DLL_Archive_FindNext = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_FindNext")
    PureLZMA_DLL_Archive_GetArchiveInfo.Proto_PureLZMA_DLL_Archive_GetArchiveInfo = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_GetArchiveInfo")
    PureLZMA_DLL_Archive_GetCRC.Proto_PureLZMA_DLL_Archive_GetCRC = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_GetCRC")
    PureLZMA_DLL_Archive_Read.Proto_PureLZMA_DLL_Archive_Read = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_Read")
    PureLZMA_DLL_Archive_ReadSFX.Proto_PureLZMA_DLL_Archive_ReadSFX = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_ReadSFX")
    PureLZMA_DLL_Archive_Update.Proto_PureLZMA_DLL_Archive_Update = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_Update")
    PureLZMA_DLL_Archive_UpdateSFX.Proto_PureLZMA_DLL_Archive_UpdateSFX = GetFunction(PureLZMA, "PureLZMA_DLL_Archive_UpdateSFX")
    ;
    PureLZMA_DLL_MemArchive_Close.Proto_PureLZMA_DLL_MemArchive_Close = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_Close")
    PureLZMA_DLL_MemArchive_Extract.Proto_PureLZMA_DLL_MemArchive_Extract = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_Extract")
    PureLZMA_DLL_MemArchive_ExtractMem.Proto_PureLZMA_DLL_MemArchive_ExtractMem = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_ExtractMem")
    PureLZMA_DLL_MemArchive_FindFirst.Proto_PureLZMA_DLL_MemArchive_FindFirst = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_FindFirst")
    PureLZMA_DLL_MemArchive_FindNext.Proto_PureLZMA_DLL_MemArchive_FindNext = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_FindNext")
    PureLZMA_DLL_MemArchive_GetArchiveInfo.Proto_PureLZMA_DLL_MemArchive_GetArchiveInfo = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_GetArchiveInfo")
    PureLZMA_DLL_MemArchive_GetCRC.Proto_PureLZMA_DLL_MemArchive_GetCRC = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_GetCRC")
    PureLZMA_DLL_MemArchive_Read.Proto_PureLZMA_DLL_MemArchive_Read = GetFunction(PureLZMA, "PureLZMA_DLL_MemArchive_Read")
  Else
    End
  EndIf
CompilerEndIf
;
; ///////////////////////////////////////////////////////////////////////////